pcl::SIFTKeypoint< PointInT, PointOutT > Class Template Reference
Module keypoints

SIFTKeypoint detects the Scale Invariant Feature Transform keypoints for a given point cloud dataset containing points and intensity. More...

`#include <pcl/keypoints/sift_keypoint.h>`

Inheritance diagram for pcl::SIFTKeypoint< PointInT, PointOutT >:

## Public Types

typedef boost::shared_ptr< SIFTKeypoint< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const SIFTKeypoint< PointInT, PointOutT > > | ConstPtr
typedef Keypoint< PointInT, PointOutT >::PointCloudIn | PointCloudIn
typedef Keypoint< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef Keypoint< PointInT, PointOutT >::KdTree | KdTree
Public Types inherited from pcl::Keypoint< PointInT, PointOutT >
typedef boost::shared_ptr< Keypoint< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Keypoint< PointInT, PointOutT > > | ConstPtr
typedef PCLBase< PointInT > | BaseClass
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(int, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, int index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| SIFTKeypoint ()
| Empty constructor. More...
void | setScales (float min_scale, int nr_octaves, int nr_scales_per_octave)
| Specify the range of scales over which to search for keypoints. More...
void | setMinimumContrast (float min_contrast)
| Provide a threshold to limit detection of keypoints without sufficient contrast. More...
Public Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
| Keypoint ()
void | harrisCorner (ImageType &output, ImageType &input, const float sigma_d, const float sigma_i, const float alpha, const float thresh)
void | hessianBlob (ImageType &output, ImageType &input, const float sigma, bool SCALE)
void | hessianBlob (ImageType &output, ImageType &input, const float start_scale, const float scaling_factor, const int num_scales)
void | imageElementMultiply (ImageType &output, ImageType &input1, ImageType &input2)
| Keypoint ()
| Empty constructor. More...
virtual | ~Keypoint ()
| Empty destructor. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for. More...
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
double | getSearchParameter ()
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection. More...
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors. More...
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
int | searchForNeighbors (int index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

bool | initCompute ()
void | detectKeypoints (PointCloudOut &output)
| Detect the SIFT keypoints for a set of points given in setInputCloud () using the spatial locator in setSearchMethod (). More...
Protected Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::Keypoint< PointInT, PointOutT >
std::string | name_
| The key point detection method's name. More...
SearchMethod | search_method_
| The search method template for indices. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT>
class pcl::SIFTKeypoint< PointInT, PointOutT >

SIFTKeypoint detects the Scale Invariant Feature Transform keypoints for a given point cloud dataset containing points and intensity.

This implementation adapts the original algorithm from images to point clouds.

For more information about the image-based SIFT interest operator, see:

David G. Lowe, "Distinctive image features from scale-invariant keypoints," International Journal of Computer Vision, 60, 2 (2004), pp. 91-110.

Author
  Michael Dixon

Definition at line 94 of file sift_keypoint.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename PointOutT>

typedef boost::shared_ptr<const SIFTKeypoint<PointInT, PointOutT> > pcl::SIFTKeypoint< PointInT, PointOutT >::ConstPtr

Definition at line 98 of file sift_keypoint.h.

## KdTree

template<typename PointInT, typename PointOutT>

typedef Keypoint<PointInT, PointOutT>::KdTree pcl::SIFTKeypoint< PointInT, PointOutT >::KdTree

Definition at line 102 of file sift_keypoint.h.

## PointCloudIn

template<typename PointInT, typename PointOutT>

typedef Keypoint<PointInT, PointOutT>::PointCloudIn pcl::SIFTKeypoint< PointInT, PointOutT >::PointCloudIn

Definition at line 100 of file sift_keypoint.h.

## PointCloudOut

template<typename PointInT, typename PointOutT>

typedef Keypoint<PointInT, PointOutT>::PointCloudOut pcl::SIFTKeypoint< PointInT, PointOutT >::PointCloudOut

Definition at line 101 of file sift_keypoint.h.

## Ptr

template<typename PointInT, typename PointOutT>

typedef boost::shared_ptr<SIFTKeypoint<PointInT, PointOutT> > pcl::SIFTKeypoint< PointInT, PointOutT >::Ptr

Definition at line 97 of file sift_keypoint.h.

## Constructor & Destructor Documentation

## SIFTKeypoint()

template<typename PointInT, typename PointOutT>

pcl::SIFTKeypoint< PointInT, PointOutT >::SIFTKeypoint | ( |  | ) |

inline

Empty constructor.

Definition at line 112 of file sift_keypoint.h.

## Member Function Documentation

## detectKeypoints()

template<typename PointInT , typename PointOutT >

void pcl::SIFTKeypoint< PointInT, PointOutT >::detectKeypoints | ( | PointCloudOut & | output | ) |

protected virtual

Detect the SIFT keypoints for a set of points given in setInputCloud () using the spatial locator in setSearchMethod ().

Parameters

  output | the resultant cloud of keypoints

Implements pcl::Keypoint< PointInT, PointOutT >.

Definition at line 98 of file sift_keypoint.hpp.

References pcl::Filter< PointT >::filter(), pcl::search::Search< PointT >::nearestKSearch(), pcl::PointCloud< PointT >::points, pcl::search::Search< PointT >::radiusSearch(), pcl::PCLBase< PointT >::setInputCloud(), pcl::VoxelGrid< PointT >::setLeafSize(), and pcl::PointCloud< PointT >::size().

## initCompute()

template<typename PointInT , typename PointOutT >

bool pcl::SIFTKeypoint< PointInT, PointOutT >::initCompute | ( |  | ) |

protected virtual

Reimplemented from pcl::Keypoint< PointInT, PointOutT >.

Definition at line 64 of file sift_keypoint.hpp.

## setMinimumContrast()

template<typename PointInT , typename PointOutT >

void pcl::SIFTKeypoint< PointInT, PointOutT >::setMinimumContrast | ( | float | min_contrast | ) |

Provide a threshold to limit detection of keypoints without sufficient contrast.

Parameters

  min_contrast | the minimum contrast required for detection

Definition at line 57 of file sift_keypoint.hpp.

## setScales()

template<typename PointInT , typename PointOutT >

void pcl::SIFTKeypoint< PointInT, PointOutT >::setScales | ( | float | min_scale,
|  | int | nr_octaves,
|  | int | nr_scales_per_octave
| ) |  |

Specify the range of scales over which to search for keypoints.

Parameters

  min_scale | the standard deviation of the smallest scale in the scale space
  nr_octaves | the number of octaves (i.e. doublings of scale) to compute
  nr_scales_per_octave | the number of scales to compute within each octave

Definition at line 47 of file sift_keypoint.hpp.

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/keypoints/include/pcl/keypoints/sift_keypoint.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/keypoints/include/pcl/keypoints/impl/sift_keypoint.hpp